pipeline {
  agent { label 'halium-7.1' }
  options {
    skipDefaultCheckout()
    buildDiscarder(logRotator(artifactNumToKeepStr: '30'))
    throttle(['halium-7.1'])
  }
  triggers {
    cron('@daily')
  }
  stages {
    stage('Build trlte') {
      steps {
        sh """#!/bin/bash
          cd /opt/halium_build/7.1/
          rm -f .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty
          cp ./halium/devices/manifests/samsung_trlte.xml .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty

          export LC_ALL=C
          export USE_CCACHE=1
          source build/envsetup.sh
          lunch lineage_trlte-userdebug
          rm -rf out/target/product/trlte/images || true
          nice make -j10
          nice make halium-boot -j10
          mkdir out/target/product/trlte/images
          mv out/target/product/trlte/*.img out/target/product/trlte/images/

          lunch lineage_trlte-eng
          nice make recoveryimage -j10
          mv out/target/product/trlte/recovery.img out/target/product/trlte/images/recovery-unlocked.img

          cd /opt/halium_build/
          ./build-tarball.sh 'trlte' '$WORKSPACE' '7.1'
        """
        archiveArtifacts(artifacts: 'halium*', fingerprint: true, onlyIfSuccessful: true)
      }
    }
    stage('Build trltetmo') {
      steps {
        sh """#!/bin/bash
          cd /opt/halium_build/7.1/
          rm -f .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty
          cp ./halium/devices/manifests/samsung_trlte.xml .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty

          export LC_ALL=C
          export USE_CCACHE=1
          source build/envsetup.sh
          lunch lineage_trltetmo-userdebug
          rm -rf out/target/product/trltetmo/images || true
          nice make -j10
          nice make halium-boot -j10
          mkdir out/target/product/trltetmo/images
          mv out/target/product/trltetmo/*.img out/target/product/trltetmo/images/

          lunch lineage_trltetmo-eng
          nice make recoveryimage -j10
          mv out/target/product/trltetmo/recovery.img out/target/product/trltetmo/images/recovery-unlocked.img

          cd /opt/halium_build/
          ./build-tarball.sh 'trltetmo' '$WORKSPACE' '7.1'
        """
        archiveArtifacts(artifacts: 'halium*', fingerprint: true, onlyIfSuccessful: true)
      }
    }
    stage('Build trltespr') {
      steps {
        sh """#!/bin/bash
          cd /opt/halium_build/7.1/
          rm -f .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty
          cp ./halium/devices/manifests/samsung_trlte.xml .repo/local_manifests/device.xml
          repo sync -j10 -c --force-sync --force-remove-dirty

          export LC_ALL=C
          export USE_CCACHE=1
          source build/envsetup.sh
          lunch lineage_trltespr-userdebug
          rm -rf out/target/product/trltespr/images || true
          nice make -j10
          nice make halium-boot -j10
          mkdir out/target/product/trltespr/images
          mv out/target/product/trltespr/*.img out/target/product/trltespr/images/

          lunch lineage_trltespr-eng
          nice make recoveryimage -j10
          mv out/target/product/trltespr/recovery.img out/target/product/trltespr/images/recovery-unlocked.img

          cd /opt/halium_build/
          ./build-tarball.sh 'trltespr' '$WORKSPACE' '7.1'
        """
        archiveArtifacts(artifacts: 'halium*', fingerprint: true, onlyIfSuccessful: true)
      }
    }
  }
  post {
    always {
      deleteDir()
    }
  }
}
